## START: Set by rpmautospec
## (rpmautospec version 0.3.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 23
%bcond_without check

%global crate below

%if 0%{?el8}
# el8 doesn't have these macros
%global __crates_url https://crates.io/api/v1/crates/
%global crates_source %{__crates_url}%{crate}/%{version}/download#/%{crate}-%{version}.crate
%global version_no_tilde %{version}
%endif

%global forgeurl https://github.com/facebookincubator/below

Name:           rust-below
Version:        0.6.3
Release:        %autorelease
Summary:        Interactive tool to view and record historical system data

License:        Apache-2.0
URL:            https://crates.io/crates/below
Source:         %{crates_source}
# Get these from the repo as they aren't included in the crate
Source1:        %{forgeurl}/raw/v%{version}/etc/below.service
Source2:        %{forgeurl}/raw/v%{version}/etc/logrotate.conf
# vendored dependencies for EPEL 8
# tar cf - Cargo.lock vendor | xz -c - > ../$(basename $(realpath .))-vendor.tar.xz
Source100:      %{crate}-%{version}-vendor.tar.xz
Source101:      README-epel.md
# Manually created patch for downstream crate metadata changes
# * bump cursive from 0.19.0 to 0.20.0
Patch:          below-fix-metadata.diff

# below-config and below-model are not available
ExcludeArch:    %{arm32} %{ix86}

%if 0%{?el8}
BuildRequires:  rust-toolset
BuildRequires:  clang
BuildRequires:  elfutils-libelf-devel
BuildRequires:  rustfmt
BuildRequires:  zlib-devel
%else
BuildRequires:  rust-packaging >= 21
%endif
BuildRequires:  systemd-rpm-macros

# List of bundled crate in vendor tarball, generated with:
# cargo metadata --locked --format-version 1 | CRATE_NAME="below" ../bundled-provides.jq
Provides: bundled(crate(ahash)) = 0.7.6
Provides: bundled(crate(ahash)) = 0.8.3
Provides: bundled(crate(aho-corasick)) = 0.7.20
Provides: bundled(crate(android_system_properties)) = 0.1.5
Provides: bundled(crate(anyhow)) = 1.0.68
Provides: bundled(crate(async-trait)) = 0.1.64
Provides: bundled(crate(atty)) = 0.2.14
Provides: bundled(crate(autocfg)) = 1.1.0
Provides: bundled(crate(below-btrfs)) = 0.6.3
Provides: bundled(crate(below-common)) = 0.6.3
Provides: bundled(crate(below-config)) = 0.6.3
Provides: bundled(crate(below-dump)) = 0.6.3
Provides: bundled(crate(below-gpu-stats)) = 0.6.3
Provides: bundled(crate(below-model)) = 0.6.3
Provides: bundled(crate(below-render)) = 0.6.3
Provides: bundled(crate(below-store)) = 0.6.3
Provides: bundled(crate(below-view)) = 0.6.3
Provides: bundled(crate(below_derive)) = 0.6.3
Provides: bundled(crate(bitflags)) = 1.3.2
Provides: bundled(crate(bumpalo)) = 3.12.0
Provides: bundled(crate(bytes)) = 1.4.0
Provides: bundled(crate(camino)) = 1.1.2
Provides: bundled(crate(cargo-platform)) = 0.1.2
Provides: bundled(crate(cargo_metadata)) = 0.14.2
Provides: bundled(crate(cc)) = 1.0.79
Provides: bundled(crate(cfg-if)) = 1.0.0
Provides: bundled(crate(cgroupfs)) = 0.6.3
Provides: bundled(crate(chrono)) = 0.4.23
Provides: bundled(crate(clap)) = 3.2.23
Provides: bundled(crate(clap_complete)) = 3.2.5
Provides: bundled(crate(clap_derive)) = 3.2.18
Provides: bundled(crate(clap_lex)) = 0.2.4
Provides: bundled(crate(codespan-reporting)) = 0.11.1
Provides: bundled(crate(console)) = 0.15.5
Provides: bundled(crate(core-foundation-sys)) = 0.8.3
Provides: bundled(crate(crossbeam-channel)) = 0.5.6
Provides: bundled(crate(crossbeam-deque)) = 0.8.2
Provides: bundled(crate(crossbeam-epoch)) = 0.9.13
Provides: bundled(crate(crossbeam-utils)) = 0.8.14
Provides: bundled(crate(crossterm)) = 0.23.2
Provides: bundled(crate(crossterm)) = 0.24.0
Provides: bundled(crate(crossterm)) = 0.25.0
Provides: bundled(crate(crossterm_winapi)) = 0.9.0
Provides: bundled(crate(cursive)) = 0.19.0
Provides: bundled(crate(cursive)) = 0.20.0
Provides: bundled(crate(cursive_buffered_backend)) = 0.6.1
Provides: bundled(crate(cursive_core)) = 0.3.7
Provides: bundled(crate(cxx)) = 1.0.88
Provides: bundled(crate(cxx-build)) = 1.0.88
Provides: bundled(crate(cxxbridge-flags)) = 1.0.88
Provides: bundled(crate(cxxbridge-macro)) = 1.0.88
Provides: bundled(crate(darling)) = 0.14.2
Provides: bundled(crate(darling_core)) = 0.14.2
Provides: bundled(crate(darling_macro)) = 0.14.2
Provides: bundled(crate(dirs-next)) = 2.0.0
Provides: bundled(crate(dirs-sys-next)) = 0.1.2
Provides: bundled(crate(either)) = 1.8.1
Provides: bundled(crate(encode_unicode)) = 0.3.6
Provides: bundled(crate(enum-map)) = 2.4.2
Provides: bundled(crate(enum-map-derive)) = 0.11.0
Provides: bundled(crate(enumset)) = 1.0.12
Provides: bundled(crate(enumset_derive)) = 0.6.1
Provides: bundled(crate(erased-serde)) = 0.3.24
Provides: bundled(crate(errno)) = 0.2.8
Provides: bundled(crate(errno-dragonfly)) = 0.1.2
Provides: bundled(crate(fastrand)) = 1.8.0
Provides: bundled(crate(fb_procfs)) = 0.6.3
Provides: bundled(crate(filetime)) = 0.2.19
Provides: bundled(crate(fnv)) = 1.0.7
Provides: bundled(crate(fuchsia-cprng)) = 0.1.1
Provides: bundled(crate(futures)) = 0.1.31
Provides: bundled(crate(futures)) = 0.3.26
Provides: bundled(crate(futures-channel)) = 0.3.26
Provides: bundled(crate(futures-core)) = 0.3.26
Provides: bundled(crate(futures-executor)) = 0.3.26
Provides: bundled(crate(futures-io)) = 0.3.26
Provides: bundled(crate(futures-macro)) = 0.3.26
Provides: bundled(crate(futures-sink)) = 0.3.26
Provides: bundled(crate(futures-task)) = 0.3.26
Provides: bundled(crate(futures-util)) = 0.3.26
Provides: bundled(crate(getrandom)) = 0.2.8
Provides: bundled(crate(half)) = 1.8.2
Provides: bundled(crate(hashbrown)) = 0.12.3
Provides: bundled(crate(heck)) = 0.3.3
Provides: bundled(crate(heck)) = 0.4.0
Provides: bundled(crate(hermit-abi)) = 0.1.19
Provides: bundled(crate(hermit-abi)) = 0.2.6
Provides: bundled(crate(hostname)) = 0.3.1
Provides: bundled(crate(humantime)) = 2.1.0
Provides: bundled(crate(iana-time-zone)) = 0.1.53
Provides: bundled(crate(iana-time-zone-haiku)) = 0.1.1
Provides: bundled(crate(ident_case)) = 1.0.1
Provides: bundled(crate(indexmap)) = 1.9.2
Provides: bundled(crate(indicatif)) = 0.17.3
Provides: bundled(crate(instant)) = 0.1.12
Provides: bundled(crate(io-lifetimes)) = 1.0.4
Provides: bundled(crate(itertools)) = 0.10.5
Provides: bundled(crate(itoa)) = 1.0.5
Provides: bundled(crate(jobserver)) = 0.1.25
Provides: bundled(crate(js-sys)) = 0.3.60
Provides: bundled(crate(lazy_static)) = 1.4.0
Provides: bundled(crate(libbpf-cargo)) = 0.13.1
Provides: bundled(crate(libbpf-rs)) = 0.19.1
Provides: bundled(crate(libbpf-sys)) = 1.1.1+v1.1.0
Provides: bundled(crate(libc)) = 0.2.139
Provides: bundled(crate(libm)) = 0.2.6
Provides: bundled(crate(link-cplusplus)) = 1.0.8
Provides: bundled(crate(linux-raw-sys)) = 0.1.4
Provides: bundled(crate(lock_api)) = 0.4.9
Provides: bundled(crate(log)) = 0.4.17
Provides: bundled(crate(maplit)) = 1.0.2
Provides: bundled(crate(match_cfg)) = 0.1.0
Provides: bundled(crate(memchr)) = 2.5.0
Provides: bundled(crate(memmap)) = 0.7.0
Provides: bundled(crate(memmap2)) = 0.5.8
Provides: bundled(crate(memoffset)) = 0.6.5
Provides: bundled(crate(memoffset)) = 0.7.1
Provides: bundled(crate(mio)) = 0.8.5
Provides: bundled(crate(nix)) = 0.24.3
Provides: bundled(crate(nix)) = 0.25.1
Provides: bundled(crate(nom8)) = 0.2.0
Provides: bundled(crate(num)) = 0.4.0
Provides: bundled(crate(num-complex)) = 0.4.3
Provides: bundled(crate(num-integer)) = 0.1.45
Provides: bundled(crate(num-iter)) = 0.1.43
Provides: bundled(crate(num-rational)) = 0.4.1
Provides: bundled(crate(num-traits)) = 0.2.15
Provides: bundled(crate(num_cpus)) = 1.15.0
Provides: bundled(crate(num_enum)) = 0.5.9
Provides: bundled(crate(num_enum_derive)) = 0.5.9
Provides: bundled(crate(num_threads)) = 0.1.6
Provides: bundled(crate(number_prefix)) = 0.4.0
Provides: bundled(crate(once_cell)) = 1.17.0
Provides: bundled(crate(openat)) = 0.1.21
Provides: bundled(crate(os_info)) = 3.6.0
Provides: bundled(crate(os_str_bytes)) = 6.4.1
Provides: bundled(crate(owning_ref)) = 0.4.1
Provides: bundled(crate(parking_lot)) = 0.12.1
Provides: bundled(crate(parking_lot_core)) = 0.9.6
Provides: bundled(crate(pin-project-lite)) = 0.2.9
Provides: bundled(crate(pin-utils)) = 0.1.0
Provides: bundled(crate(pkg-config)) = 0.3.26
Provides: bundled(crate(plain)) = 0.2.3
Provides: bundled(crate(portable-atomic)) = 0.3.19
Provides: bundled(crate(portpicker)) = 0.1.1
Provides: bundled(crate(ppv-lite86)) = 0.2.17
Provides: bundled(crate(proc-macro-crate)) = 1.3.0
Provides: bundled(crate(proc-macro-error)) = 1.0.4
Provides: bundled(crate(proc-macro-error-attr)) = 1.0.4
Provides: bundled(crate(proc-macro2)) = 1.0.50
Provides: bundled(crate(quote)) = 1.0.23
Provides: bundled(crate(rand)) = 0.4.6
Provides: bundled(crate(rand)) = 0.8.5
Provides: bundled(crate(rand_chacha)) = 0.3.1
Provides: bundled(crate(rand_core)) = 0.3.1
Provides: bundled(crate(rand_core)) = 0.4.2
Provides: bundled(crate(rand_core)) = 0.6.4
Provides: bundled(crate(rand_distr)) = 0.4.3
Provides: bundled(crate(rayon)) = 1.6.1
Provides: bundled(crate(rayon-core)) = 1.10.2
Provides: bundled(crate(rdrand)) = 0.4.0
Provides: bundled(crate(redox_syscall)) = 0.2.16
Provides: bundled(crate(redox_users)) = 0.4.3
Provides: bundled(crate(regex)) = 1.7.1
Provides: bundled(crate(regex-syntax)) = 0.6.28
Provides: bundled(crate(remove_dir_all)) = 0.5.3
Provides: bundled(crate(rustix)) = 0.36.7
Provides: bundled(crate(rustversion)) = 1.0.11
Provides: bundled(crate(ryu)) = 1.0.12
Provides: bundled(crate(same-file)) = 1.0.6
Provides: bundled(crate(scopeguard)) = 1.1.0
Provides: bundled(crate(scratch)) = 1.0.3
Provides: bundled(crate(scroll)) = 0.11.0
Provides: bundled(crate(scroll_derive)) = 0.11.0
Provides: bundled(crate(semver)) = 1.0.16
Provides: bundled(crate(serde)) = 1.0.152
Provides: bundled(crate(serde_cbor)) = 0.11.2
Provides: bundled(crate(serde_derive)) = 1.0.152
Provides: bundled(crate(serde_json)) = 1.0.91
Provides: bundled(crate(signal-hook)) = 0.3.14
Provides: bundled(crate(signal-hook-mio)) = 0.2.3
Provides: bundled(crate(signal-hook-registry)) = 1.4.0
Provides: bundled(crate(slab)) = 0.4.7
Provides: bundled(crate(slog)) = 2.7.0
Provides: bundled(crate(slog-term)) = 2.9.0
Provides: bundled(crate(smallvec)) = 1.10.0
Provides: bundled(crate(stable_deref_trait)) = 1.2.0
Provides: bundled(crate(static_assertions)) = 1.1.0
Provides: bundled(crate(strsim)) = 0.10.0
Provides: bundled(crate(strum_macros)) = 0.23.1
Provides: bundled(crate(syn)) = 1.0.107
Provides: bundled(crate(tar)) = 0.4.38
Provides: bundled(crate(tempdir)) = 0.3.7
Provides: bundled(crate(tempfile)) = 3.3.0
Provides: bundled(crate(term)) = 0.7.0
Provides: bundled(crate(termcolor)) = 1.2.0
Provides: bundled(crate(terminal_size)) = 0.2.3
Provides: bundled(crate(textwrap)) = 0.16.0
Provides: bundled(crate(thiserror)) = 1.0.38
Provides: bundled(crate(thiserror-impl)) = 1.0.38
Provides: bundled(crate(thread_local)) = 1.1.4
Provides: bundled(crate(threadpool)) = 1.8.1
Provides: bundled(crate(time)) = 0.3.17
Provides: bundled(crate(time-core)) = 0.1.0
Provides: bundled(crate(time-macros)) = 0.2.6
Provides: bundled(crate(tokio)) = 1.25.0
Provides: bundled(crate(toml)) = 0.5.8
Provides: bundled(crate(toml_datetime)) = 0.5.1
Provides: bundled(crate(toml_edit)) = 0.18.1
Provides: bundled(crate(unicase)) = 2.6.0
Provides: bundled(crate(unicode-ident)) = 1.0.6
Provides: bundled(crate(unicode-segmentation)) = 1.10.1
Provides: bundled(crate(unicode-width)) = 0.1.10
Provides: bundled(crate(users)) = 0.11.0
Provides: bundled(crate(version_check)) = 0.9.4
Provides: bundled(crate(vsprintf)) = 2.0.0
Provides: bundled(crate(walkdir)) = 2.3.2
Provides: bundled(crate(wasi)) = 0.11.0+wasi_snapshot_preview1
Provides: bundled(crate(wasm-bindgen)) = 0.2.83
Provides: bundled(crate(wasm-bindgen-backend)) = 0.2.83
Provides: bundled(crate(wasm-bindgen-macro)) = 0.2.83
Provides: bundled(crate(wasm-bindgen-macro-support)) = 0.2.83
Provides: bundled(crate(wasm-bindgen-shared)) = 0.2.83
Provides: bundled(crate(winapi)) = 0.3.9
Provides: bundled(crate(winapi-i686-pc-windows-gnu)) = 0.4.0
Provides: bundled(crate(winapi-util)) = 0.1.5
Provides: bundled(crate(winapi-x86_64-pc-windows-gnu)) = 0.4.0
Provides: bundled(crate(windows-sys)) = 0.42.0
Provides: bundled(crate(windows_aarch64_gnullvm)) = 0.42.1
Provides: bundled(crate(windows_aarch64_msvc)) = 0.42.1
Provides: bundled(crate(windows_i686_gnu)) = 0.42.1
Provides: bundled(crate(windows_i686_msvc)) = 0.42.1
Provides: bundled(crate(windows_x86_64_gnu)) = 0.42.1
Provides: bundled(crate(windows_x86_64_gnullvm)) = 0.42.1
Provides: bundled(crate(windows_x86_64_msvc)) = 0.42.1
Provides: bundled(crate(xattr)) = 0.2.3
Provides: bundled(crate(xi-unicode)) = 0.3.0
Provides: bundled(crate(zstd-safe)) = 5.0.2+zstd.1.5.2
Provides: bundled(crate(zstd-sys)) = 2.0.6+zstd.1.5.2

%global _description %{expand:
below is an interactive tool to view and record historical system data. It has
support for:

- information regarding hardware resource utilization
- viewing the cgroup hierarchy
- cgroup and process information
- pressure stall information (PSI)
- record mode to record system data
- replay mode to replay historical system data
- live mode to view live system data
- dump subcommand to report script-friendly information (e.g. JSON and CSV)

below does not have support for cgroup1.

The name "below" stems from the fact that the below developers rejected many of
atop's design and style decisions.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
License:        Apache-2.0 AND (Apache-2.0 OR MIT) AND Unicode-DFS-2016 AND (Apache-2.0 OR BSL-1.0) AND BSD-2-Clause AND (Apache-2.0 OR BSD-3-Clause OR MIT) AND (BSD-2-Clause OR LGPL-2.1) AND MIT AND (MPL-2.0 OR MIT OR Apache-2.0) AND (Unlicense OR MIT)
# LICENSE.dependencies contains a full license breakdown

Recommends:     logrotate

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE
%if 0%{?fedora}
%license LICENSE.dependencies
%endif
%doc README.md
%if 0%{?el8}
%doc README-epel.md
%endif
%{_bindir}/below
%{_unitdir}/%{crate}.service
%dir %{_sysconfdir}/logrotate.d
%config(noreplace) %{_sysconfdir}/logrotate.d/%{crate}.conf
%dir %{_localstatedir}/log/%{crate}

%post        -n %{crate}
%systemd_post %{crate}.service

%preun       -n %{crate}
%systemd_preun %{crate}.service

%postun      -n %{crate}
%systemd_postun_with_restart %{crate}.service

%prep
%autosetup -n %{crate}-%{version_no_tilde} -p1
%if 0%{?el8}
cp -p %{SOURCE101} .
%cargo_prep -V100
%else
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires
%endif

%build
%cargo_build
%if 0%{?fedora}
%{cargo_license} > LICENSE.dependencies
%endif

%install
%cargo_install
install -D -p -m0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{crate}.service
install -D -p -m0644 %{SOURCE2} \
  %{buildroot}%{_sysconfdir}/logrotate.d/%{crate}.conf
install -d -m1777 %{buildroot}%{_localstatedir}/log/%{crate}

%if %{with check}
%check
%ifarch aarch64
# thread 'test::record_replay_integration' panicked at 'missing io.stat', src/test.rs:102:10
%cargo_test -- -- --skip test::record_replay_integration
%else
%cargo_test
%endif
%endif

%changelog
* Wed Feb 01 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.6.3-4
- Vendor dependencies for EPEL 8
- bundled-provides.jq script courtesy of the zincati src.rpm

* Mon Jan 30 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.6.3-2
- Exclude builds on 32-bit architectures

* Thu Jan 26 2023 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.6.3-1
- Update to 0.6.3

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sat Feb 19 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.5.0-2
- Update binary package license (fixes: rhbz#2045491)

* Fri Feb 18 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.5.0-1
- Update to 0.5.0

* Tue Feb 15 2022 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 0.4.1-4
- Rebuild with package notes

* Tue Jan 25 2022 Fabio Valentini <decathorpe@gmail.com> - 0.4.1-3
- Rebuild with thread_local 1.1.4 for RUSTSEC-2022-0006

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Nov 11 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.1-1
- Update to 0.4.0; Fixes: RHBZ#2022244

* Thu Oct 28 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.0-2
- Update vendoring logic to fix the epel8 build; Fixes: RHBZ#1978414

* Fri Oct 22 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.4.0-1
- Update to 0.4.0; Fixes: RHBZ#2016559

* Sat Jul 31 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.3.0-1
- Update to 0.3.0; Fixes: RHBZ#1983801

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jul  6 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.2.0-4
- Add README-epel.md with instructions for enabling PSI support
- Gate ExclusiveArch s390x to el8 only

* Wed Jun 30 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.2.0-3
- Add vendored dependencies for EPEL and make it build there
- Exclude s390x for the EPEL build for now due to an upstream issue
- Mark logrotate config file as a config(noreplace)
- Add recommends for logrotate
- Fix permissions for the below binary

* Mon Jun 28 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.2.0-2
- Install upstream systemd unit
- Install upstream logrotate config
- Add missing documentation
- Expand the description

* Tue Jun 15 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.2.0-1
- Initial package

